import '../../../numdart/numdart.dart';

///  Divide all the columns by a Array
///  Examples
///  --------
///  >>> var a = Array2d([
///  >>>   Array([2, 2, 2]),
///  >>>   Array([2, 2, 2]),
///  >>>   Array([2, 2, 2])
///  >>> ]);
///  >>> var b = Array([2, 2, 2]);
///  >>> matrixDivideColumns(a, b);
///  Array2d([
///    Array([1, 1, 1]),
///    Array([1, 1, 1]),
///    Array([1, 1, 1])
///  ]);
Array2d matrixDivideColumns(Array2d a, Array b) {
  a.isMatrix();

  int aRows = a.length;
  int aColumns = a[0].length;
  int bColumns = b.length;

  if (aColumns != bColumns) {
    throw FormatException(
        "Then length of B need be the same length of columns of A");
  }

  var c = Array2d.fromArray(a); // make a copy of local

  for (int i = 0; i < aRows; i++) {
    //
    for (int j = 0; j < aColumns; j++) {
      // bColumn
      c[i][j] /= b[i];
    }
  }

  return c;
}
